#include <windows.h>
#include "CMemoryFileMap.h"

CMemoryFileMap::CMemoryFileMap(){
	m_hFile = NULL;
	m_bInitial = FALSE;
	m_hMutex = NULL;
	m_pFileMap = NULL;
	m_hOrgFile = INVALID_HANDLE_VALUE;
}

CMemoryFileMap::~CMemoryFileMap(){
	ReleaseData();
}

///////////////////////////////////////////////////
// API

///////////////////////////////////////////////////
//t@C}bv
//:	pszFileMapName -> t@C}bv
//		pszMutexName	-> ~[ebNX
//		dwDataSize -> mۂ郁TCY
//߂l:TRUE AFALSE s
BOOL CMemoryFileMap::Initialize(char *pFileName, char *pszFileMapName,DWORD dwDataSize){
	BOOL	bInit = TRUE;
	HANDLE hFistFile;
	WIN32_FIND_DATA wfdata;

	// ς݂Ȃ珉Ȃ
	if ( !m_bInitial ){
		if(pFileName != NULL){

			hFistFile = FindFirstFile(pFileName,&wfdata);
			if(hFistFile != INVALID_HANDLE_VALUE){
				FindClose(hFistFile);
				dwDataSize = 0;
			}

			m_hOrgFile = CreateFile(pFileName,
									GENERIC_READ|GENERIC_WRITE,
									FILE_SHARE_READ | FILE_SHARE_WRITE,
									NULL,
									OPEN_ALWAYS,
									FILE_ATTRIBUTE_NORMAL|FILE_FLAG_WRITE_THROUGH,
									NULL);
		}
		else{
			m_hOrgFile = INVALID_HANDLE_VALUE;
		}

		// t@C}bv𐶐
		m_hFile = CreateFileMapping(
							m_hOrgFile,
							NULL,
							PAGE_READWRITE,
							NULL,
							dwDataSize,
							pszFileMapName);
		if ( !m_hFile ){
			// s
			bInit = FALSE;
		}
		// t@C}bvQ
		m_pFileMap = MapViewOfFile(
								m_hFile,
								FILE_MAP_ALL_ACCESS,
								NULL,
								NULL,
								0);
		if ( !m_pFileMap ){
			// s
			bInit = FALSE;
		}else{
			// f[^
			ZeroMemory(m_pFileMap,dwDataSize);
		}
		
	}else{
		// ɏς
		return TRUE;
	}

	// ɎsĂȂ
	if ( !bInit ){
		// Sf[^̉
		ReleaseData();
		return FALSE;
	}

	
	// 
	m_bInitial = TRUE;

	return TRUE;

}

///////////////////////////////////////////////////
//쐬ς݂̃t@C}bvJ
//:pszFileMapName -> t@C}bv
//߂l:TRUE -> 
//       FALSE -> s(t@C}bv)
BOOL CMemoryFileMap::OpenFileMap(char *pszFileMapName){

	// ς݂Ȃ珉Ȃ
	if(m_bInitial == TRUE) return TRUE;

	// t@C}bvI[v
	m_hFile = OpenFileMapping(
					FILE_MAP_WRITE,
					NULL,
					pszFileMapName);

	if(m_hFile == NULL) return FALSE;

	// f[^|C^擾
	m_pFileMap = MapViewOfFile(
							m_hFile,
							FILE_MAP_ALL_ACCESS,
							NULL,
							NULL,
							0);

	if(m_pFileMap == NULL){
		ReleaseData();
		return FALSE;
	}

	// 
	m_bInitial = TRUE;

	return TRUE;
}


///////////////////////////////////////////////////
// SẴf[^j
void CMemoryFileMap::ReleaseData(void)
{

	if ( m_pFileMap )
		UnmapViewOfFile(m_pFileMap);
	if ( m_hFile )
		CloseHandle(m_hFile);
	if(m_hOrgFile != INVALID_HANDLE_VALUE){
		CloseHandle(m_hOrgFile);
		m_hOrgFile = INVALID_HANDLE_VALUE;
	}
	if ( m_hMutex ){
		::ReleaseMutex(m_hMutex );
		::CloseHandle(m_hMutex);
	}

	m_hFile = NULL;
	m_pFileMap = NULL;
	m_hMutex = NULL;

	m_bInitial = FALSE;
}

///////////////////////////////////////////////////
//~[ebNXݒ肷
//:pszMutexName -> ~e[bNX
//߂l:TRUE 쐬AFALSE 쐬Ɏs
BOOL CMemoryFileMap::SetMutex(char *pszMutexName){
	if(m_hMutex != NULL) return TRUE;
	
	m_hMutex = CreateMutex(NULL,FALSE,pszMutexName);
	if ( m_hMutex == NULL){
		return FALSE;
	}
	if(WaitForSingleObject(m_hMutex,0) == WAIT_TIMEOUT){
		::CloseHandle(m_hMutex);
		m_hMutex = NULL;
		return FALSE;
	}
	
	return TRUE;
}

///////////////////////////////////////////////////
//~[ebNX
//:Ȃ
//߂l:Ȃ
void CMemoryFileMap::ReleaseMutex(void){
	if ( m_hMutex != NULL){
		::ReleaseMutex(m_hMutex );
		::CloseHandle(m_hMutex);
		m_hMutex = NULL;
	}
}

///////////////////////////////////////////////////
//ϐ擾po֐
HANDLE CMemoryFileMap::GetFileHadle(void){
	return m_hFile;
}

BOOL CMemoryFileMap::IsInitial(void){
	return m_bInitial;
}

HANDLE CMemoryFileMap::GetMutexHandle(void){
	return m_hMutex;
}

LPVOID CMemoryFileMap::GetFileMap(void){
	return m_pFileMap;
}
