#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdio.h>
#include "CMiniCtrlWnd.h"
#include "..\util\StrUtil.h"
#include "..\resource.h"

#define APP_REG_WND_INFO "Software\\PetitTV\\Player\\Window"

CMiniCtrlWnd::CMiniCtrlWnd(){
	m_hWnd = NULL;
	m_hInst = NULL;
	m_pcSetting = NULL;
}

CMiniCtrlWnd::~CMiniCtrlWnd(){
}

HWND CMiniCtrlWnd::CreateWnd(DWORD dwExStyle,DWORD dwStyle,
					int x,int y,int nWidth,int nHeight,
					HWND hwndParent,
					HMENU hmenu,
					HINSTANCE hinst){
					
	if(m_hWnd != NULL)return m_hWnd;

	m_hWnd = CreateWindowEx(dwExStyle,
							CBASE_WINDOW_CLASS,
							NULL,dwStyle,
							x,y,nWidth,nHeight,
							hwndParent,
							hmenu,hinst,(VOID *)this);

	m_hInst = hinst;
	m_hWOwner = hwndParent;

	return m_hWnd;
}

///////////////////////////////////////////////////////////////
//ԕۑp֐
BOOL CMiniCtrlWnd::SaveWndPos(void){
	int lRet;
	HKEY hKey;
	WINDOWPLACEMENT wndpl;

	if(m_hWnd == NULL) return FALSE;
	
	ZeroMemory(&wndpl,sizeof(WINDOWPLACEMENT));
	wndpl.length = sizeof(WINDOWPLACEMENT);
	lRet = GetWindowPlacement(m_hWnd,&wndpl);

	if(lRet != 0){

		lRet = RegOpenKeyEx(HKEY_CURRENT_USER,APP_REG_WND_INFO,0,KEY_WRITE,&hKey);
		if(lRet != ERROR_SUCCESS){
			lRet = RegCreateKeyEx(HKEY_CURRENT_USER,APP_REG_WND_INFO,0,NULL,0,KEY_ALL_ACCESS, NULL, &hKey, NULL);
			if(lRet != ERROR_SUCCESS){
				MessageBox(m_hWnd,"WXg̍쐬Ɏs܂B","Error",MB_OK|MB_ICONERROR);
				return FALSE;
			}
		}
	
		RegSetValueEx(hKey,"Main_Left"		,0,REG_DWORD	,(CONST BYTE *)&wndpl.rcNormalPosition.left		,sizeof(wndpl.rcNormalPosition.left));
		RegSetValueEx(hKey,"Main_Top"		,0,REG_DWORD	,(CONST BYTE *)&wndpl.rcNormalPosition.top		,sizeof(wndpl.rcNormalPosition.top));
		RegSetValueEx(hKey,"Main_Right"		,0,REG_DWORD	,(CONST BYTE *)&wndpl.rcNormalPosition.right	,sizeof(wndpl.rcNormalPosition.right));
		RegSetValueEx(hKey,"Main_Bottom"	,0,REG_DWORD	,(CONST BYTE *)&wndpl.rcNormalPosition.bottom	,sizeof(wndpl.rcNormalPosition.bottom));

		RegCloseKey(hKey);
	}
	
	return TRUE;
}

BOOL CMiniCtrlWnd::LoadWndPos(RECT *pRc){
	int lRet;
	HKEY hKey;
	DWORD dwType;
	DWORD cbData;

	if(pRc == NULL)return FALSE;

	lRet = RegOpenKeyEx(HKEY_CURRENT_USER,APP_REG_WND_INFO,0,KEY_READ,&hKey);
	if(lRet != ERROR_SUCCESS) return FALSE;

	dwType = REG_DWORD;	cbData = sizeof(pRc->left);
	lRet = RegQueryValueEx(hKey,"Main_Left",NULL,&dwType,(BYTE *)&pRc->left,&cbData);
	if(lRet != ERROR_SUCCESS) return FALSE;
	
	dwType = REG_DWORD;	cbData = sizeof(pRc->top);
	lRet = RegQueryValueEx(hKey,"Main_Top",NULL,&dwType,(BYTE *)&pRc->top,&cbData);
	if(lRet != ERROR_SUCCESS) return FALSE;
	
	dwType = REG_DWORD;	cbData = sizeof(pRc->right);
	lRet = RegQueryValueEx(hKey,"Main_Right",NULL,&dwType,(BYTE *)&pRc->right,&cbData);
	if(lRet != ERROR_SUCCESS) return FALSE;

	dwType = REG_DWORD;	cbData = sizeof(pRc->bottom);
	lRet = RegQueryValueEx(hKey,"Main_Bottom",NULL,&dwType,(BYTE *)&pRc->bottom,&cbData);
	if(lRet != ERROR_SUCCESS) return FALSE;

	RegCloseKey(hKey);

	return TRUE;
}

BOOL CMiniCtrlWnd::SetChannel(int nidx){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_CH_RMT_0IDX+nidx,0),0);
	return TRUE;
}

BOOL CMiniCtrlWnd::SetSkin(char *pszSkinFile){
	RECT rc;
	
	m_cViewPlayer.ReleaseSprite();

	m_cViewPlayer.SetToolTipsActivate(FALSE);

	if(m_cViewPlayer.ReadSkinData(pszSkinFile) == FALSE)return FALSE;

	SetWindowPos(m_hWnd,NULL,0,0,
		m_cViewPlayer.GetSkinWidth(),m_cViewPlayer.GetSkinHeight(),
		SWP_NOMOVE|SWP_NOZORDER);

	GetClientRect(m_hWnd,&rc);
	m_cViewPlayer.SetDrawRect(&rc);
	m_cViewPlayer.SetWindowForm();

	m_cViewPlayer.SetTooltipRect();
	m_cViewPlayer.SetToolTipsActivate(TRUE);

	return TRUE;
}

void CMiniCtrlWnd::put_cSetting(CSetting *pSetting){
	m_pcSetting = pSetting;
	m_cViewPlayer.put_cSetting(pSetting);
}

void CMiniCtrlWnd::DrawVolume(long lVolume){
	m_cViewPlayer.DrawVolume(lVolume);
}

void CMiniCtrlWnd::DrawButton(void){
	m_cViewPlayer.DrawButton();
}

void CMiniCtrlWnd::DrawPlayerStat(int nAppStat){
	m_cViewPlayer.DrawPlayerStat(nAppStat);
}

void CMiniCtrlWnd::DrawPlayerInfo(void){
	m_cViewPlayer.DrawPlayerInfo();
}

void CMiniCtrlWnd::DrawClock(int nTime){
	m_cViewPlayer.DrawClock(nTime);
}

BOOL CMiniCtrlWnd::UpdateView(ST_CV_PLY_FUNC_PARAM *pParam){

	HDC hdc;
	RECT rc;

	GetClientRect(m_hWnd,&rc);
	hdc = GetDC(m_hWnd);
	if(hdc != NULL){
		m_cViewPlayer.DrawAll(hdc,rc,pParam);
		ReleaseDC(m_hWnd,hdc);
	}

	return TRUE;
}

void CMiniCtrlWnd::SetVolumeCallBack(LPPROC_AudioVolume pProc,LPVOID lParam){
	m_cViewPlayer.SetVolumeCallBack(pProc,lParam);
}

void CMiniCtrlWnd::SetPlayerInfo(char *pszInfo){
	m_cViewPlayer.SetPlayerInfo(pszInfo);
}

BOOL CMiniCtrlWnd::IsSamePlayerInfo(char *pszInfo){
	return m_cViewPlayer.IsSamePlayerInfo(pszInfo);
}

//////////////////////////////////////////////////////////////////////////////
//R}hnh
void CMiniCtrlWnd::OnClose(void){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_PLAYER,0),0);
}

void CMiniCtrlWnd::OnCh01(void){
	SetChannel(0);
}

void CMiniCtrlWnd::OnCh02(void){
	SetChannel(1);
}

void CMiniCtrlWnd::OnCh03(void){
	SetChannel(2);
}

void CMiniCtrlWnd::OnCh04(void){
	SetChannel(3);
}

void CMiniCtrlWnd::OnCh05(void){
	SetChannel(4);
}

void CMiniCtrlWnd::OnCh06(void){
	SetChannel(5);
}

void CMiniCtrlWnd::OnCh07(void){
	SetChannel(6);
}

void CMiniCtrlWnd::OnCh08(void){
	SetChannel(7);
}

void CMiniCtrlWnd::OnCh09(void){
	SetChannel(8);
}

void CMiniCtrlWnd::OnCh10(void){
	SetChannel(9);
}

void CMiniCtrlWnd::OnCh11(void){
	SetChannel(10);
}

void CMiniCtrlWnd::OnCh12(void){
	SetChannel(11);
}

void CMiniCtrlWnd::OnCfg(void){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_CFG,0),0);
}

void CMiniCtrlWnd::OnStop(void){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_STOP,0),0);
}

void CMiniCtrlWnd::OnRec(void){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_REC_START,0),0);
}

void CMiniCtrlWnd::OnSnapShot(void){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_SNAPSHOT,0),0);
}

void CMiniCtrlWnd::OnVolumeUp(void){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_VOL_UP,0),0);
}

void CMiniCtrlWnd::OnVolumeDown(void){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_VOL_DOWN,0),0);
}

void CMiniCtrlWnd::OnMute(void){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_VOL_MUTE,0),0);
}

void CMiniCtrlWnd::OnChannelUp(void){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_CH_UP,0),0);
}

void CMiniCtrlWnd::OnChannelDown(void){
	PostMessage(m_hWOwner,WM_COMMAND,MAKELONG(IDM_CH_DOWN,0),0);
}

void CMiniCtrlWnd::OnIEPG(void){
}


//////////////////////////////////////////////////////////////////////////////
//bZ[Wnh
LRESULT CMiniCtrlWnd::OnWmCreate(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){

	char szSkinFile[MAX_PATH];
	char szSkinPath[MAX_PATH];

	//CX^X擾
	m_hInst = (HINSTANCE)GetWindowLong(hW,GWL_HINSTANCE);
	m_hWnd = hW;

	//XL̐ݒs
	m_cViewPlayer.SetInstance(m_hInst);
	m_cViewPlayer.SetWindow(m_hWnd);
	m_cViewPlayer.SetSkinFolder(MINCTRL_SKIN_PATH);
	m_cViewPlayer.InitToolTip();

	//XL[h
	szSkinFile[0] = '\0';
	if(m_pcSetting != NULL){
		m_pcSetting->get_SkinFile(&szSkinFile[0]);
	}

	if(szSkinFile[0] == '\0'){
		strcpy(szSkinFile,"PetitTV.SKN");
	}

	if(SetSkin(szSkinFile) == FALSE){
		MessageBox(hW,"XL̓ǂݍ݂Ɏs܂B\nW̃XLgp܂B","G[",MB_OK);
		
		strcpy(szSkinFile,"PlayTV.SKN");
		_snprintf(szSkinPath,MAX_PATH-1,"%s%s",MINCTRL_SKIN_PATH,szSkinFile);

		SetSkin(szSkinPath);
	}

	return 0;
}

LRESULT CMiniCtrlWnd::OnWmMouseMove(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){

	int xPos = GET_X_LPARAM(lParam);	// J[\̐̈ʒu
	int yPos = GET_Y_LPARAM(lParam);	// J[\̐̈ʒu
	HDC hdc;

	hdc = GetDC(hW);

	m_cViewPlayer.OnWmMouseMove(hdc,xPos,yPos,NULL);

	ReleaseDC(hW,hdc);

	return 0;
}

LRESULT CMiniCtrlWnd::OnWMLButtonDown(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	
	POINT pos;
	HDC hdc;

	int xPos = GET_X_LPARAM(lParam);	// J[\̐̈ʒu
	int yPos = GET_Y_LPARAM(lParam);	// J[\̐̈ʒu

	if(m_cViewPlayer.IsButton(xPos,yPos,NULL) == FALSE){
		//݈ړ̏s
		GetCursorPos(&pos);
		PostMessage(hW,WM_NCLBUTTONDOWN,(WPARAM)HTCAPTION,MAKELONG(pos.x,pos.y));
	}
	else{
		hdc = GetDC(hW);
		m_cViewPlayer.OnWMLButtonDown(hdc,xPos,yPos);
		ReleaseDC(hW,hdc);
	}

	return 0;
}

LRESULT CMiniCtrlWnd::OnWMLButtonUp(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	HDC hdc;
	int nBtnID;

	int xPos = GET_X_LPARAM(lParam);	// J[\̐̈ʒu
	int yPos = GET_Y_LPARAM(lParam);	// J[\̐̈ʒu

	hdc = GetDC(hW);

	m_cViewPlayer.OnWMLButtonUp(hdc,xPos,yPos,&nBtnID,NULL);
	switch(nBtnID){
	case PTDIGI_FUNC_Close:
		OnClose();
		break;
	case PTDIGI_FUNC_Config:
		OnCfg();
		break;
	case PTDIGI_FUNC_Ch01:
		OnCh01();
		break;
	case PTDIGI_FUNC_Ch02:
		OnCh02();
		break;
	case PTDIGI_FUNC_Ch03:
		OnCh03();
		break;
	case PTDIGI_FUNC_Ch04:
		OnCh04();
		break;
	case PTDIGI_FUNC_Ch05:
		OnCh05();
		break;
	case PTDIGI_FUNC_Ch06:
		OnCh06();
		break;
	case PTDIGI_FUNC_Ch07:
		OnCh07();
		break;
	case PTDIGI_FUNC_Ch08:
		OnCh08();
		break;
	case PTDIGI_FUNC_Ch09:
		OnCh09();
		break;
	case PTDIGI_FUNC_Ch10:
		OnCh10();
		break;
	case PTDIGI_FUNC_Ch11:
		OnCh11();
		break;
	case PTDIGI_FUNC_Ch12:
		OnCh12();
		break;
	case PTDIGI_FUNC_STOP:
		OnStop();
		break;
	case PTDIGI_FUNC_REC:
		OnRec();
		break;
	case PTDIGI_FUNC_SnapShot:
		OnSnapShot();
		break;
	case PTDIGI_FUNC_VolumeUP:
		OnVolumeUp();
		break;
	case PTDIGI_FUNC_VolumeDown:
		OnVolumeDown();
		break;
	case PTDIGI_FUNC_Mute:
	case PTDIGI_FUNC_MuteOff:
		OnMute();
		break;
	case PTDIGI_FUNC_ChannelUP:
		OnChannelUp();
		break;
	case PTDIGI_FUNC_ChannelDown:
		OnChannelDown();
		break;
	}
	
	ReleaseDC(hW,hdc);

	return 0;
}

LRESULT CMiniCtrlWnd::OnWMLButtonDbclk(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	
	int xPos = GET_X_LPARAM(lParam);	// J[\̐̈ʒu
	int yPos = GET_Y_LPARAM(lParam);	// J[\̐̈ʒu

	if(m_cViewPlayer.IsButton(xPos,yPos,NULL) == TRUE){
#ifdef IDC_CURSOR_HAND
		SetCursor(LoadCursor(m_hInst,MAKEINTRESOURCE(IDC_CURSOR_HAND)));
#endif //IDC_CURSOR_HAND
	}

	return 0;
}

LRESULT CMiniCtrlWnd::OnWmRButtonDown(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	
	POINT pos;

	HWND hWParent = GetParent(hW);
	if(hWParent != NULL){
		GetCursorPos(&pos);
		ScreenToClient(hWParent,&pos);
		SendMessage(hWParent,WM_RBUTTONDOWN,0,MAKELONG(pos.x,pos.y));
	}

	return 0;

}

LRESULT CMiniCtrlWnd::OnWmCommand(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){
	return 0;
}

LRESULT CMiniCtrlWnd::OnWmPaint(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){

	HDC hdc;
	PAINTSTRUCT ps;

	hdc = BeginPaint(hW,&ps);

	RECT rc;
	ST_CV_PLY_FUNC_PARAM stParam;
	ZeroMemory(&stParam,sizeof(stParam));

	if(m_pcSetting != NULL){
		stParam.bIsMute = m_pcSetting->get_IsMute();
		stParam.lVolume = m_pcSetting->get_AudioVolume();
	}

	GetClientRect(hW,&rc);
	m_cViewPlayer.DrawAll(hdc,rc,&stParam);

	EndPaint(hW,&ps);

	return TRUE;
}

LRESULT CMiniCtrlWnd::OnWmClose(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){

	//ݒZ[u

	SaveWndPos();

	//EChEj
	DestroyWindow(hW);

	return 0;
}

LRESULT CMiniCtrlWnd::OnWmDestroy(HWND hW,UINT uMsg,WPARAM wParam, LPARAM lParam){

	m_hWnd = NULL;

	return 0;
}

LRESULT CMiniCtrlWnd::WndProck(HWND hW, UINT uMsg, WPARAM wParam, LPARAM lParam){
	LONG lRet = 0;
	switch (uMsg){
	case WM_PAINT:
		lRet = OnWmPaint(hW,uMsg,wParam,lParam);
		break;
	case WM_DESTROY:
		lRet = OnWmDestroy(hW,uMsg,wParam,lParam);
		break;
	case WM_CLOSE:
		lRet = OnWmClose(hW,uMsg,wParam,lParam);
		break;
	case WM_CREATE:
		lRet = OnWmCreate(hW,uMsg,wParam,lParam);
		break;
	case WM_COMMAND:
		lRet = OnWmCommand(hW, uMsg, wParam, lParam);
		break;
	case WM_MOUSEMOVE:
		lRet = OnWmMouseMove(hW, uMsg, wParam, lParam);
		break;
	case WM_LBUTTONDOWN:
		lRet = OnWMLButtonDown(hW, uMsg, wParam, lParam);
		break;
	case WM_LBUTTONUP:
		lRet = OnWMLButtonUp(hW, uMsg, wParam, lParam);
		break;
	case WM_LBUTTONDBLCLK:
		lRet = OnWMLButtonDbclk(hW, uMsg, wParam, lParam);
		break;
	case WM_RBUTTONDOWN:
		lRet = OnWmRButtonDown(hW, uMsg, wParam, lParam);
		break;
	default:
		lRet = DefWindowProc(hW,uMsg,wParam,lParam);
		break;
	}

	return lRet;
}
